﻿Type=StaticCode
Version=4.19
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Dim s As String = ""
	Dim returnType As String
	Dim javaLine,subName,params As String
	Dim isArrayReturn,isMultiParams,isArrayParams As Boolean
	Dim isStatic,isFinal As Boolean

End Sub
Sub buildJo(st As String) As String
	decodeJavaLine(st)
	javaLine = st
	removeDesc
	getReturnType
	getName
	getParams
	buildCode
	Return s
End Sub
Sub removeDesc ' this may need some work
	If javaLine.StartsWith("public") Then 
		javaLine = javaLine.Replace("public ","")'.Replace("static ","").Replace("final ","")
	End If
	' may use these later
	If javaLine.Contains("static") Then isStatic = True Else isStatic = False
	If javaLine.Contains("final") Then isFinal = True Else isFinal = False
	javaLine = javaLine.Replace("static ","").Replace("final ","")
End Sub
Sub getReturnType
	returnType = javaLine.SubString2(0,javaLine.IndexOf(" ")).Replace("java.lang.","")
	If returnType.Contains("[]") Then
		isArrayReturn = True
	Else
		isArrayReturn = False	
	End If
End Sub
Sub getName
	subName = javaLine.SubString2(javaLine.IndexOf(" ")+1,javaLine.IndexOf("("))
	subName = subName.SubString(subName.lastIndexOf(".")+1)
End Sub
Sub getParams
	params = javaLine.SubString2(javaLine.IndexOf("(")+1,javaLine.IndexOf(")"))
	If params.Contains(",") Then
		isMultiParams = True
	Else
		isMultiParams = False
	End If
	If params.Contains("[]") Then
		isArrayParams = True
	Else
		isArrayParams = False	
	End If
	params = params.Replace("java.lang.","") ' remove the standard classes
End Sub
Sub buildCode
	' build sub line
	s = ""
	s = s & "'++++++++++++++++++++++++" & CRLF
	s = s & "'++ AutoGenerated Code ++" & CRLF
	s = s & "'++ Orig Java : "&javaLine & CRLF
	s = s & "'++++++++++++++++++++++++" & CRLF
	If params.Contains(",") Then
		s = s & "' Arguments are : "
		For Each splitParam As String In Regex.Split(",",params)
			s = s & splitParam.Replace("[]","()") & " ,"
		Next
		If s.EndsWith(",") Then 
			s = s.SubString2(0,s.Length-1)
		End If
		s = s & CRLF
	Else
		If params <> "" Then 
			s = s & "' Argument is : " & params & CRLF
		Else
			s = s & "' Argument is : Null" & CRLF
		End If	
	End If
	If returnType <> "" Then
		s = s & "' Return is : " & returnType & CRLF
	Else
		s = s & "' Return is : Null (Void)" & CRLF
	End If
	Dim ts As String = Main.TextField1.Text
	If ts.Contains(".") Then
		ts = ts.SubString(ts.LastIndexOf(".")+1) '  
	End If
	If ts.Contains(" ") Then
		s = s & $"Sub ${ts.SubString2(0,ts.IndexOf(" "))}_${subName}"$
	Else
		s = s & $"Sub ${ts}_${subName}"$	
	End If
	s = s &$"(ob As JavaObject"$
	If params.Length > 0 Then
		If Not(isMultiParams) Then
			s = s & $", arg As ${convertParamType(params)})"$
		Else
			Dim argCnt As Int = 1
			For Each splitParam As String In Regex.Split(",",params)
				If Not(splitParam.Contains("[]")) Then 
					s = s & ", Arg" & argCnt&" As " & convertParamType(splitParam)
				Else
					s = s & ", Arg" & argCnt & "() As " & convertParamType(splitParam.Replace("[]",""))
				End If
				argCnt = argCnt + 1
			Next
		s = s & " )"
		End If
	Else
		s = s &")"
	End If
	If returnType<>"void" Then
		If Not(isArrayReturn) Then
			s = s & $" As ${convertParamType(returnType)}"$
		Else
			s = s & $" As Array"$
		End If
	End If
	s = s & CRLF
	' build call line
	s = s & TAB & $"ob.RunMethod("${subName}""$
	If params.Length > 0 Then
		If Not(isMultiParams) Then
			s = s & $",Array(arg))"$
		Else
			s = s & $",Array("$
			Dim argCnt As Int = 1
			For Each splitParam As String In Regex.Split(",",params)
				If argCnt = 1 Then
						s = s & " Arg" & argCnt
				Else
						s = s & ", Arg" & argCnt
				End If		 
				argCnt = argCnt + 1
			Next
		s = s & " ))"
		End If
	Else
		s = s & $",null)"$
	End If
	s = s & CRLF
	' handle return
	If returnType<> "void" Then
		s = s.Replace("ob.Run","Return ob.Run")
	End If
	' end sub
	s = s & "End Sub" & CRLF
End Sub
Sub buildConstructor(li As List)
	For Each item As String In li
		Dim sc As String = ""
		Dim start As String = item.SubString2(item.IndexOf(" "),item.IndexOf("("))
		If item.EndsWith("()") Then
			sc = sc & "'---------------------------"&CRLF
			sc = sc & "'-- Constructor()        ---"&CRLF
			sc = sc & "'---------------------------"&CRLF
			sc = sc & "Sub new_"
			sc = sc & item.SubString2(item.LastIndexOf(".")+1,item.IndexOf("("))& _
			" As "& convertParamType(item.SubString2(item.LastIndexOf(".")+1,item.IndexOf("(")))&CRLF
			sc = sc & TAB & "Dim jo"&item.SubString2(item.LastIndexOf(".")+1,item.IndexOf("("))& " As JavaObject" & CRLF
			sc = sc & TAB & " jo"& item.SubString2(item.LastIndexOf(".")+1,item.IndexOf("("))
			If item.Contains("static") Then
				sc = sc & $".InitializeStatic(""$&item.SubString2(item.IndexOf(" ")+1,item.IndexOf("("))
				sc = sc & $"")"$ & CRLF
			Else
				sc = sc & $".InitializeNewInstance(""$&item.SubString2(item.IndexOf(" ")+1,item.IndexOf("("))
				sc = sc & $"",null)"$ & CRLF
			End If
			sc = sc & TAB & "Return jo"& item.SubString2(item.LastIndexOf(".")+1,item.IndexOf("("))
			sc = sc & CRLF & "End Sub"   
		Else
			sc = sc & "'---------------------------"&CRLF
			sc = sc & "'-- Constructor(args...) ---"&CRLF
			sc = sc & "'-- Params: " & item.SubString2(item.IndexOf("(")+1,item.IndexOf(")"))&CRLF
			sc = sc & "'---------------------------"&CRLF
			sc = sc & "Sub new_"
			sc = sc & start.SubString(start.LastIndexOf(".")+1)& "( "
			Dim pcount As Int = 0
			For Each arg As String In splitParms(item.SubString2(item.IndexOf("(")+1,item.IndexOf(")")))
				If pcount = 0 Then
					If arg.Contains("[]") Then
						sc = sc & "Arg"&pcount&"() As "& convertParamType(arg.SubString2(arg.LastIndexOf(".")+1,arg.IndexOf("[")))
					Else
						sc = sc & "Arg"&pcount&" As "& convertParamType(arg.SubString(arg.LastIndexOf(".")+1))
					End If
				Else
					If arg.Contains("[]") Then
						sc = sc & ", Arg"&pcount&"() As "& convertParamType(arg.SubString2(arg.LastIndexOf(".")+1,arg.LastIndexOf("[")))
					Else
						sc = sc & ", Arg"&pcount&" As "& convertParamType(arg.SubString(arg.LastIndexOf(".")+1))
					End If
				End If
				pcount = pcount + 1
			Next
			sc = sc & ") As "& convertParamType(start.SubString(start.LastIndexOf(".")+1))&CRLF
			If item.Contains("static") Then
				sc = sc & $".InitializeStatic(""$&item.SubString2(item.IndexOf(" ")+1,item.IndexOf("("))
				sc = sc & ",Array("
				For x = 0 To pcount -1
					If x = 0 Then 
						sc = sc & " Arg"&x
					Else
						sc = sc & ", Arg"&x
					End If
				Next
				sc = sc & "))" & CRLF
			Else
				sc = sc & TAB & "Dim jo"& start.SubString(start.LastIndexOf(".")+1)& " As JavaObject" & CRLF
				sc = sc & TAB & " jo"& start.SubString(start.LastIndexOf(".")+1)
				sc = sc & $".InitializeNewInstance(""$&item.SubString2(item.IndexOf(" ")+1,item.IndexOf("("))
				sc = sc & $"",Array("$
				For x = 0 To pcount -1
					If x = 0 Then 
						sc = sc & " Arg"&x
					Else
						sc = sc & ", Arg"&x
					End If
				Next
				sc = sc & "))" & CRLF
			End If
			sc = sc & TAB & "Return jo"& start.SubString(start.LastIndexOf(".")+1)
			sc = sc & CRLF & "End Sub"&CRLF	
		End If
		'Log(sc)
		Main.TextArea1.Text = Main.TextArea1.Text & sc & CRLF
	Next
End Sub
Sub splitParms(st As String) As String()
	Dim tmp() As String
	tmp = Regex.Split(",",st)
	Return tmp
End Sub
' convert to B4J types or JavaObject if no equivalent
Sub convertParamType(st As String) As String
	If st.Contains(".") And (st.Contains("javafx") Or st.Contains("java.util") Or st.Contains("java.lang")) Then
		st = st.SubString(st.LastIndexOf(".")+1)
	End If
	st = st.Replace("[]","()")
	st = st.Replace("...","()") ' replace varArgs > real array
	Select st
		Case "ObservableList"
			Return "List"
		Case "Color"	
			Return "Paint"
		Case "TableColumn"
			Return "JavaObject"
		Case "double"
			Return "Double"
		Case "float"
			Return "Float"
		Case "short"
			Return "Short"
		Case "byte"
			Return "Byte"
		Case "char"
			Return "Char"
		Case "TableCell","BigInteger"
			Return "JavaObject"
	End Select
	Return st
End Sub
' this is just for testing out ideas
Sub decodeJavaLine(st As String)
	Log(st)
	Dim isThisStatic As Boolean
	Dim returnClass As String
	Dim functionName As String
	Dim theseParams As String
	st = st.Replace("public ","")
	If st.Contains("static") Then 
		isThisStatic = True
		st = st.Replace("static ","")
	End If
	returnClass = st.SubString2(0,st.IndexOf(" "))
	st = st.Replace(returnClass & " ","")
	functionName = st.SubString2(0,st.IndexOf("("))
	st = st.Replace(functionName,"")
	theseParams = st.SubString2(1,st.LastIndexOf(")"))
	Log($"static : ${isThisStatic} returns: ${returnClass} Name: ${functionName} takes: ${theseParams}"$)
	Dim ss As String
	Dim ssb As StringBuilder
	ssb.Initialize
	ssb.Append("Sub ")
	'name
	Dim tf As String = Main.TextField1.Text
	If tf.Contains(" ") Then
		ssb.Append(tf.SubString2(0,tf.IndexOf(" ")))
	Else
		ssb.Append(tf)
	End If
	'_function name
	ssb.Append("_"&functionName.SubString(functionName.LastIndexOf(".")+1))
	' params
	If theseParams = "" Then
		ssb.Append("(ob As JavaObject)")
	Else
		ssb.Append("(ob As JavaObject")
		Dim ssp() As String
		ssp = Regex.Split(",",theseParams)
		Dim sspc As Int =0
		For Each par As String In ssp
			ssb.Append( ", Arg"&sspc& " As "&par)
			sspc = sspc+1
		Next
		ssb.Append(" )")
	End If
	If returnClass <>"" Then
		ssb.Append(" As "&returnClass)
	End If
	ss = ssb
	Log(ss)
End Sub
